import {system, world, BlockPermutation} from "@minecraft/server";
const debugBuffer = 2000;
const delimiter = "–";

export function info(line) {
	log_message(`§bINFO§r: ${line}`);
	if (!(world.getDynamicProperty("ljw_br:enable_debug_logging") ?? false)) return;
	sendMessage(`[DEBUG] §bINFO§r: ${line}`);
	console.warn(`[DEBUG] INFO: ${line}`);
}
export function warn(line) {
	log_message(`§eWARN§r: ${line}`);
	if (!(world.getDynamicProperty("ljw_br:enable_debug_logging") ?? false)) return;
	sendMessage(`[DEBUG] §eWARN§r: ${line}`);
	console.warn(`[DEBUG] WARN: ${line}`);
}
export function error(line) {
	log_message(`§cERROR§r: ${line}`);
	if (!(world.getDynamicProperty("ljw_br:enable_debug_logging") ?? false)) return;
	sendMessage(`[DEBUG] §cERROR§r: ${line}`);
	console.warn(`[DEBUG] ERROR: ${line}`);
}
function sendMessage(line) {
	const debugPlayers = world.getPlayers({tags: ["ljw_br_debug_chat"]});
	for (const debugPlayer of debugPlayers) {
		debugPlayer.sendMessage(line);
	}
}

function log_message(line) {
	const current = (world.getDynamicProperty("ljw_br:debug_log") ?? "");
	world.setDynamicProperty("ljw_br:debug_log", (current + line + delimiter).substr(Math.max(0, current.length + line.length - debugBuffer), current.length + line.length + 1));
}

system.afterEvents.scriptEventReceive.subscribe(e => {
	if (e.id == "ljw_br:toggle_debug")
	{
		world.setDynamicProperty("ljw_br:enable_debug_logging", !(world.getDynamicProperty("ljw_br:enable_debug_logging") ?? false));
		world.sendMessage(`Debug logging: ${(world.getDynamicProperty("ljw_br:enable_debug_logging") ?? false)}`);
	}
	else if (e.id == "ljw_br:debug_log")
	{
		const lines = (world.getDynamicProperty("ljw_br:debug_log") ?? "").split(delimiter);
		for (const line of lines)
			world.sendMessage(`${line}`);
	}
});